
import datetime
import uuid

from nsj_rest_lib.entity.entity_base import EntityBase
from nsj_rest_lib.decorator.entity import Entity


@Entity(
    table_name="financas.titulos",
    pk_field="id",
    default_order_fields=["id"],
)
class TituloEntity(EntityBase):
    id: uuid.UUID = None
    tenant: int = None
    sinal: int = None
    origem: int = None
    numero: str = None
    emissao: datetime.datetime = None
    vencimento: datetime.datetime = None
    situacao: int = None
    parcela: int = None
    totalparcelas: int = None
    tppessoa: int = None
    observacao: str = None
    valor: float = None
    valorbruto: float = None
    irretido: float = None
    cofinsretido: float = None
    pisretido: float = None
    csllretido: float = None
    inssretido: float = None
    issretido: float = None
    desconto: float = None
    juros: float = None
    multa: float = None
    taxabancaria: float = None
    despesasbancarias: float = None
    anotacao: str = None
    id_docfis: uuid.UUID = None
    id_estabelecimento: uuid.UUID = None
    id_pessoa: uuid.UUID = None
    id_darf: uuid.UUID = None
    id_gnre: uuid.UUID = None
    id_gps: uuid.UUID = None
    id_icmsiss: uuid.UUID = None
    id_outdoc: uuid.UUID = None
    previsaovencimento: datetime.datetime = None
    percentualdesconto: float = None
    datalimitedesconto: datetime.datetime = None
    percentualmulta: float = None
    datainiciomulta: datetime.datetime = None
    percentualjurosdiario: float = None
    codigocontabil: str = None
    parcelapedidovenda: uuid.UUID = None
    nossonumero: str = None
    linhadigitavel: str = None
    codigobarras: str = None
    conta: uuid.UUID = None
    previsaoreceber: uuid.UUID = None
    aliquotapis: float = None
    aliquotacofins: float = None
    aliquotacsll: float = None
    aliquotair: float = None
    layoutcobranca: uuid.UUID = None
    documentorateado: uuid.UUID = None
    rps: uuid.UUID = None
    situacaotexto: str = None
    origemtexto: str = None
    emissaotexto: str = None
    vencimentotexto: str = None
    valorbrutotexto: str = None
    emissaoanomes: str = None
    emissaodia: str = None
    vencimentoanomes: str = None
    vencimentodia: str = None
    formapagamento: int = None
    vezescartao: int = None
    valortarifacartao: float = None
    autorizacaocartao: str = None
    formapagamentotexto: str = None
    documentocartao: str = None
    numeroparcelacartao: int = None
    aliquotaiss: float = None
    pedidovenda: uuid.UUID = None
    informacaocartao: uuid.UUID = None
    valorparcelacartao: float = None
    previsaopagar: uuid.UUID = None
    numeronota: str = None
    tipopagamento: int = None
    layoutpagamento: uuid.UUID = None
    dataagendamento: datetime.datetime = None
    modelodocumentofiscal: int = None
    seriedocumentofiscal: str = None
    subseriedocumentofiscal: str = None
    tipocontabilizacao: int = None
    identificadorbancario: int = None
    finalidadedocbradesco: str = None
    tipodecontabradesco: str = None
    id_rps: uuid.UUID = None
    previsaovencimentotexto: str = None
    id_pedido: uuid.UUID = None
    id_fatura: uuid.UUID = None
    id_servicobanco: uuid.UUID = None
    id_formapagamentobanco: uuid.UUID = None
    id_finalidadepagamentobanco: uuid.UUID = None
    id_tipocontapagamentobanco: uuid.UUID = None
    id_servicons: uuid.UUID = None
    id_formapagamentons: uuid.UUID = None
    id_finalidadepagamentons: uuid.UUID = None
    id_tipocontapagamentons: uuid.UUID = None
    lastupdate: datetime.datetime = None
    id_bempatrimonial: uuid.UUID = None
    codigodocedenteboleto: str = None
    numerodocumentoboleto: str = None
    especieboleto: str = None
    aceiteboleto: bool = None
    dataprocessamentoboleto: datetime.datetime = None
    usobancoboleto: str = None
    carteiraboleto: str = None
    datacompetenciatributos: datetime.datetime = None
    codigodareceitatributos: str = None
    numerodereferenciadarf: str = None
    outrosacrescimos: float = None
    percentualoutrosacrescimos: float = None
    modoexibicaomulta: str = None
    modoexibicaojuros: str = None
    modoexibicaooutros: str = None
    modoexibicaocodigobarras: str = None
    valorreceitabrutaacumuladadarfsimples: float = None
    percreceitabrutaacumuladadarfsimples: float = None
    numerodeclaracaogare: str = None
    numeroetiquetagare: str = None
    numerodaparcelagare: str = None
    codigorenavam: str = None
    unidadefederacaoipva: str = None
    codigomunicipioipva: str = None
    placaveiculoipva: str = None
    opcaodepagamentoipva: str = None
    opcaoretiradacrlv: str = None
    identificadorfgts: str = None
    lacreconectividadesocial: str = None
    numerodocumentodarj: str = None
    dataprovisoria: bool = None
    valorprovisorio: bool = None
    adiantamento: bool = None
    saldoadiantamento: float = None
    debitoautomatico: bool = None
    irretidonf: float = None
    inssretidonf: float = None
    id_contrato: uuid.UUID = None
    modoexibicaodesconto: str = None
    id_dfparcela: uuid.UUID = None
    id_formapagamento: uuid.UUID = None
    id_fatura_mercadoria: uuid.UUID = None
    id_renegociacao_geradora: uuid.UUID = None
    id_renegociacao_gerada: uuid.UUID = None
    id_renegociacao_baixa: uuid.UUID = None
    usadiscriminacao: bool = None
    wkf_estado: str = None
    wkf_data: datetime.datetime = None
    valorvariacaocambialativa: float = None
    valorvariacaocambialpassiva: float = None
    emprestimo: bool = None
    id_contaemprestimo: uuid.UUID = None
    id_conjunto_anexo: uuid.UUID = None
    numerodocumento: str = None
    datacompetencia: datetime.datetime = None
    usuarioresponsavel: uuid.UUID = None
    chavepersona: str = None
    tipoordempagamento: int = None
    id_template: uuid.UUID = None
    id_usuario_cadastro: uuid.UUID = None
    datahoracriacao: datetime.datetime = None
    dataautorizacaocartao: datetime.datetime = None
    id_prestacaodeconta: uuid.UUID = None
    titulocoberturaconta: bool = None
    coberturaconta: uuid.UUID = None
    documentorateadocobertura: uuid.UUID = None
    id_documento_associado: uuid.UUID = None
    contafornecedor: uuid.UUID = None
    previsto: bool = None
    pagamento: uuid.UUID = None
    parcelapagamento: uuid.UUID = None
    importacao_hash: str = None
    contabilizado: bool = None
    cfop_codigo: str = None
    id_titulovinculo_previsao: uuid.UUID = None
    id_previsao_vinculada: uuid.UUID = None
    id_proposta: uuid.UUID = None
    rps_old: uuid.UUID = None
    num: str = None
    id_erp: int = None
    estorno: bool = None
    id_titulo_estorno: uuid.UUID = None
    tipoestorno: int = None
    statusestorno: int = None
    id_titulo_estornado_clone: uuid.UUID = None
    pisestornado: float = None
    cofinsestornado: float = None
    csllestornado: float = None
    irestornado: float = None
    inssestornado: float = None
    issestornado: float = None
