
import datetime
import uuid

from nsj_rest_lib.entity.entity_base import EntityBase
from nsj_rest_lib.decorator.entity import Entity


@Entity(
    table_name="ns.df_docfis",
    pk_field="id",
    default_order_fields=["modelo"],
)
class DfDocfiEntity(EntityBase):
    id: uuid.UUID = None
    tenant: int = None
    id_ano: int = None
    sinal: int = None
    tipo: int = None
    modelo: str = None
    serie: str = None
    subserie: str = None
    numero: str = None
    periodo: int = None
    lancamento: datetime.datetime = None
    emissao: datetime.datetime = None
    cfop: str = None
    cfopservico: str = None
    tppessoa: int = None
    atenumero: str = None
    datainiserv: datetime.datetime = None
    datafimserv: datetime.datetime = None
    datasaida: datetime.datetime = None
    datadeclaracao: datetime.datetime = None
    datanotaconhec: datetime.datetime = None
    horasaida: datetime.time = None
    porcaixa: bool = None
    petroleo: bool = None
    notafatura: bool = None
    cfopdif: bool = None
    cfopserdif: bool = None
    cancelado: bool = None
    orgaopublico: bool = None
    somaiss: bool = None
    issoutromunic: bool = None
    retautomatica: bool = None
    retemiss: bool = None
    retemir: bool = None
    reteminss: bool = None
    retemcofins: bool = None
    retemcsll: bool = None
    retempis: bool = None
    retorno: bool = None
    porcontigencia: bool = None
    situacao: int = None
    situacaosped: int = None
    tipocalctrib: int = None
    tpligacao: int = None
    grupotensao: int = None
    crt: int = None
    messerv: int = None
    anoserv: int = None
    tiponfe: int = None
    tpoperador: int = None
    tpconsignatario: int = None
    consumidor: int = None
    tiporedespacho: int = None
    remas: int = None
    rapis: int = None
    tipofrete: int = None
    tiporecolhimento: int = None
    tipotransporte: int = None
    volumes: int = None
    tipodocexterior: int = None
    parcelas: int = None
    tipocontab: int = None
    mesescredicms: int = None
    anoaidf: int = None
    anopexpam: int = None
    tipoimp: int = None
    classe: int = None
    tiporeceita: int = None
    tipoconsumo: int = None
    tiponavegacao: int = None
    tipoveiculo: int = None
    naturezafrete: int = None
    tipotarifaar: int = None
    chavene: str = None
    chaveneini: str = None
    chavene01: str = None
    chavene02: str = None
    chavene03: str = None
    chavene04: str = None
    chavenefim: str = None
    codigoirrf: str = None
    codigopis: str = None
    codigocsll: str = None
    codigocofins: str = None
    numacdraw: str = None
    campoligacao: str = None
    terminal: str = None
    codarea: str = None
    rntrc: str = None
    serierps: str = None
    rps: str = None
    cnae: str = None
    codmunic: str = None
    codserv: str = None
    municdest: str = None
    codif: str = None
    numerofrete: str = None
    marca: str = None
    tipovolume: str = None
    placa: str = None
    placa02: str = None
    placa03: str = None
    ufplaca: str = None
    ufplaca02: str = None
    ufplaca03: str = None
    doccomexterior: str = None
    parcelamento: str = None
    renavam: str = None
    codigodip: str = None
    observacao: str = None
    obsestoque: str = None
    selofiscal: str = None
    aidf: str = None
    numeropexpam: str = None
    lacre: str = None
    unidadecarga: str = None
    frota: str = None
    veiculo: str = None
    viagem: str = None
    otm: str = None
    frete: float = None
    seguro: float = None
    basetransp: float = None
    iss: float = None
    deducaoiss: float = None
    inss: float = None
    ir: float = None
    valoriss: float = None
    baseiss: float = None
    baseinss: float = None
    valorinss: float = None
    valorinssadicional: float = None
    valorinssnaoretido: float = None
    valorinsssubempreitada: float = None
    baseir: float = None
    valorir: float = None
    basecofins: float = None
    valorcofins: float = None
    basecsll: float = None
    valorcsll: float = None
    basepis: float = None
    valorpis: float = None
    deducaobaseir: float = None
    valordeducaoir: float = None
    desconto: float = None
    mercadorias: float = None
    servicos: float = None
    valor: float = None
    diferenca: float = None
    valordestacado: float = None
    baseicms: float = None
    icms: float = None
    valoricms: float = None
    icmsnaocred: float = None
    isentasicms: float = None
    outrasicms: float = None
    reducaoicms: float = None
    reducaoipi: float = None
    baseipi: float = None
    valoripi: float = None
    ipi: float = None
    isentasipi: float = None
    outras: float = None
    basesubst: float = None
    substprop: float = None
    substterc: float = None
    substnaoret: float = None
    icmsretido: float = None
    pisimp: float = None
    cofinsimp: float = None
    basepisimp: float = None
    basecofinsimp: float = None
    valorpisimp: float = None
    valorcofinsimp: float = None
    consumo: float = None
    kwh: float = None
    fretemm: float = None
    pesotx: float = None
    freteliquido: float = None
    valorsec_cat: float = None
    despacho: float = None
    pedagio: float = None
    despportuarias: float = None
    cargadescarga: float = None
    taxaterrestre: float = None
    advalorem: float = None
    valorgris: float = None
    outrosvalores: float = None
    pesobruto: float = None
    pesoliquido: float = None
    cubagem: float = None
    anotacoes: str = None
    percbaseinss: float = None
    percbaseir: float = None
    id_itemntr: uuid.UUID = None
    id_conhectransp: uuid.UUID = None
    id_estabelecimento: uuid.UUID = None
    id_orgao: uuid.UUID = None
    id_operador: uuid.UUID = None
    id_redespachador: uuid.UUID = None
    id_emitente: uuid.UUID = None
    id_pessoa: uuid.UUID = None
    id_consignatario: uuid.UUID = None
    id_coleta: uuid.UUID = None
    id_entrega: uuid.UUID = None
    id_remetente: uuid.UUID = None
    id_destinatario: uuid.UUID = None
    id_transportadora: uuid.UUID = None
    id_motorista: uuid.UUID = None
    id_obra: uuid.UUID = None
    id_grupodiferenciado: uuid.UUID = None
    id_scp: uuid.UUID = None
    tipodocumento: int = None
    xml_docengine: str = None
    xml_transmitido: str = None
    tipopedido: int = None
    formapagamento: int = None
    autorizacaocartao: str = None
    documentocartao: str = None
    dataautorizacaocartao: datetime.datetime = None
    valoravista: float = None
    vezescartao: int = None
    anotacao: str = None
    id_proposta: uuid.UUID = None
    id_grupoempresarial: uuid.UUID = None
    id_promocao: uuid.UUID = None
    id_posicaoworkflow: uuid.UUID = None
    id_midiaorigem: uuid.UUID = None
    id_conta: uuid.UUID = None
    id_layoutbancario: uuid.UUID = None
    id_informacaocartao: uuid.UUID = None
    datanegocio: datetime.datetime = None
    aprovadopor: uuid.UUID = None
    datahoraaprovacao: datetime.datetime = None
    acrescimofinanceiro: float = None
    origem: int = None
    id_objetoservico: uuid.UUID = None
    id_docfis: uuid.UUID = None
    id_cfop: uuid.UUID = None
    discriminacaoservicos: str = None
    statusrps: int = None
    tiporps: int = None
    tipotributacaoservicorps: int = None
    regimeespecialtributacao: int = None
    incentivocultural: int = None
    ufprestacaoservico: str = None
    cidadeprestacaoservico: str = None
    id_estabelecimentocontraparte: uuid.UUID = None
    descricaopagamento: str = None
    datavalidade: datetime.datetime = None
    contato: str = None
    informacoespedido: str = None
    id_oportunidade: uuid.UUID = None
    id_parcelamento: uuid.UUID = None
    id_docproposta: uuid.UUID = None
    xml_cancelamento: str = None
    motivo_cancelamento: str = None
    data_cancelamento: datetime.datetime = None
    datacriacao: datetime.datetime = None
    horacriacao: datetime.time = None
    referenciaexterna: str = None
    tipoordemservico: str = None
    origemordemservico: int = None
    contrato: uuid.UUID = None
    processamentocontrato: uuid.UUID = None
    id_pedido: uuid.UUID = None
    documento_operacao: uuid.UUID = None
    documento_operacao_codigo: str = None
    xml_titulos: str = None
    lastupdate: datetime.datetime = None
    ordemservico_id: uuid.UUID = None
    valorliquido: float = None
    caixa: int = None
    pontodevenda: uuid.UUID = None
    id_serie: uuid.UUID = None
    dataentradasaida: datetime.datetime = None
    tipoemitente: int = None
    tiporeceptor: int = None
    formadepagamento: int = None
    tipooperacao: int = None
    uffatogerador: str = None
    modocompra: int = None
    tipodeemissao: int = None
    chave: str = None
    observacao_movimentacao: str = None
    tabeladepreco: uuid.UUID = None
    id_localdeestoqueorigem: uuid.UUID = None
    id_localdeestoquedestino: uuid.UUID = None
    df_endereco_retirada: uuid.UUID = None
    df_endereco_entrega: uuid.UUID = None
    municipiofatogerador: str = None
    xml_contingencia: str = None
    datacontingencia: datetime.datetime = None
    justificativacontingencia: str = None
    debitoautomatico: bool = None
    contigencia_justificativa: str = None
    contigencia_imprimiu: bool = None
    contigencia_datahora: datetime.datetime = None
    numeroprotocolo: str = None
    tipoambiente: int = None
    lotecobrancaordemservico_id: uuid.UUID = None
    documentorateado: uuid.UUID = None
    requisicaoalmoxarifado_id: uuid.UUID = None
    gerafinanceiro: bool = None
    id_conjunto_anexo: uuid.UUID = None
    descricaoservicos: str = None
    rps_original: uuid.UUID = None
    tipo_retencao_iss: int = None
    xml_rps: str = None
    anotacoes_sistema: str = None
    anotacoes_manuais: str = None
    uf_embarque: str = None
    local_embarque: str = None
    local_despacho: str = None
    origemdocumento: int = None
    link_nfse: str = None
    id_documento_vinculado: uuid.UUID = None
    pessoamunicipio: uuid.UUID = None
    id_usuario_cadastro: uuid.UUID = None
    prazoentrega: int = None
    notaimportacao: int = None
    chavegold: str = None
    wkf_data: datetime.datetime = None
    wkf_estado: str = None
    usuario_solicitacao_id: uuid.UUID = None
    usuario_solicitacao_data: datetime.datetime = None
    situacaogerencial: int = None
    emailenviado: bool = None
    totalvalorfaturar: float = None
    id_instancia: uuid.UUID = None
    finalidadeemissao: int = None
    id_operacao_nfs: uuid.UUID = None
    analistacompra: uuid.UUID = None
    infopiscompra: float = None
    infocofinscompra: float = None
    infoicmscompra: float = None
    infoicmsstcompra: float = None
    infoipicompra: float = None
    status: int = None
    vendedor: uuid.UUID = None
    categoriadeproduto: uuid.UUID = None
    uf_habilitacao: str = None
    tipo_assinante: int = None
    autenticacao_lote_digital: str = None
    outras_retencoes: float = None
    numero_titulo: str = None
    vbcufdest: float = None
    pfcpufdest: float = None
    picmsufdest: float = None
    picmsinter: float = None
    picmsinterpart: float = None
    vfcpufdest: float = None
    vicmsufdest: float = None
    vicmsufremet: float = None
    dataprevisao_entradasaida: datetime.datetime = None
    template_discriminacaorps: uuid.UUID = None
    codigo_verificacao: str = None
    id_contratofinanceiro: str = None
    id_cotacao: uuid.UUID = None
    id_docfis_contrato: uuid.UUID = None
    id_moeda: uuid.UUID = None
    id_opeinterna: uuid.UUID = None
    id_pedidoservico: uuid.UUID = None
    id_rateiopadrao: uuid.UUID = None
    id_transacaofinanceira: str = None
    iddest: int = None
    iddestinoremessa: uuid.UUID = None
    indfinal: int = None
    indiedest: int = None
    indpres: int = None
    lotedigital: uuid.UUID = None
    naturezaoperacao: str = None
    nota_antecipada: bool = None
    numeroexterno: str = None
    observacao_dadosgerais: str = None
    outrosacrescimos: float = None
    possuiadiantamento: bool = None
    pretituloverificado: bool = None
    projeto_padrao_id: uuid.UUID = None
    rascunho: bool = None
    recalcularimpostos: bool = None
    reconstruirxml: bool = None
    reinf_maodeobra: str = None
    rota: uuid.UUID = None
    rota_liberado: bool = None
    sistema: int = None
    status_conferencia: int = None
    tabeladefrete: uuid.UUID = None
    tipo_insercao: int = None
    tipointegracao_pagamento: int = None
    titulo_observacao: str = None
    total_desconto: float = None
    troco: float = None
    versao_dfe: str = None
    volumemanual: bool = None
    xmlexplodido: bool = None
    pedido_mobile_efetivacao: datetime.datetime = None
    romaneio_doc_atendido: bool = None
    idregrapagamento: uuid.UUID = None
